
#define MAXCONN 100
#define MAX_USER_THREADS 4 
#define DEFAULT_PORT 5555
#define GC_TIME 300 

#ifdef WINDOWS
#define SHUT_RDWR SD_BOTH
#endif

/* YOU MAY NOT EDIT THIS NEXT TWO LINES OF CODE */
#define VERSION "Mandel Server January 9, 2005"
#define COPYRIGHT "Copyright 2004-2005 Michael Kohn"
/* THIS IS NOT GPL */

struct User
{
  unsigned char location[64];
  unsigned char outString[514];
  unsigned char myString[514];
  int ID,r;
  int channel,uflags;
  int logontime,idletime,stamptime;
  char inuse;
  int socketid;
  int lr,lptr,ptr;
  int curr_frame,upload_len;
  FILE *out,*socketfd;
};

struct mandelbrot_t
{
  int width;
  int height;
  double real_start;
  double real_end;
  double imaginary_start;
  double imaginary_end;
  int count;
  double zoom_length;
  int frames;
  double real_start_last;
  double real_end_last;
  double imaginary_start_last;
  double imaginary_end_last;
  double rs_step;
  double re_step;
  double is_step;
  double ie_step;
};

extern int sockfd,port;
extern struct User **users; 
extern struct mandelbrot_t mandelbrot;
extern int debug;
extern unsigned int uptime;
extern unsigned short int serverflags;
extern char configdir[256];
extern int maxconn;
extern int minconn;
extern int max_idle_time;
extern FILE *fp;

/*

Server Flags

0: channel disallow
1: host lookups
2: show ips
3: no dup ips
4: elite mode
5: force password
6: force names
7: no duplicate names
8: no name changing

*/

/*

User Flags
0: Beeps
1: Hilites
2: Squelched
3: Hush Yells
4: Echos
5: Time Stamping
6: System Messages
7: Hidden Sysop
8: Client Userlist
9: User already changed their name

*/


